<%@ page language="java" contentType="text/html; charset=utf-8" %>
<%@taglib uri="/WEB-INF/taglib.tld" prefix="x" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<html>
<head>
    <x:base include="layout,dialog,grid,tree,combox,commonTree,date"/>
    <x:script src='/biz/topsun/sap/nonProdApply/nonProdApplyMRP.js'/>
</head>

<body>
<x:hidden name="isDetailPage" value="false"/> <!--是否是详情页-->
<x:hidden name="deptCode" value="false"/> <!--是否是详情页-->

<div class="container-fluid" style="padding: 10px;">
    <x:billTitle title="非产品/非本成品类物料MRP信息维护" needStatus="false" needPerson="true"/>

    <form class="hg-form" method="post" action="" id="submitForm">
        <x:hidden name="active"/> <!--状态-->
        <x:hidden name="meId"/> <!--状态-->
        <div style="float: right; margin-right: 10px;display: none;" class="btn-group" id="buttonBox">
            <button id="save" title="" type="button" onclick="saveForm(0)" class="btn btn-gray"><i
                    class="fa fa-save"></i>保存
            </button>
            <button id="submit" title="" type="button" onclick="saveForm(1)" class="btn btn-gray"><i
                    class="fa fa-save"></i>提交
            </button>
            <button id="back" title="" type="button" onclick="clearForm()" class="btn btn-gray"><i
                    class="fa fa-reply"></i>撤销
            </button>
            <button id="showChart" title="" type="button" onclick="distributeForm()" class="btn btn-gray"><i
                    class="fa fa-sitemap"></i>分发
            </button>
        </div>
        <br/>

        <div class=" border-left-top" style="margin-top: 20px;display: none;" id="causeBox">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <h4>驳回历史</h4>
                </div>
                <div class="hg-form-cols" id="cause-details-box"></div>
            </div>
        </div>

        <x:hidden name="applyDeptId"/>
        <x:hidden name="id"/>
        <x:hidden name="businessCode"/>
        <x:title title="基本信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="billCode" label="申请单编号" labelCol="1" readonly="true" fieldCol="2"/>
                <x:selectC name="statusId" label="批准状态" dictionary="bizBillStatus" disabled="true" labelCol="1"
                           fieldCol="2"/>
                <x:inputC name="personMemberName" label="填写人" readonly="true" labelCol="1" fieldCol="2"/>
                <x:inputC name="fillinDate" label="填写日期" readonly="true" wrapper="date" labelCol="1" fieldCol="2"/>
            </div>
            <div class="hg-form-row">
                <x:radioC name="maintenanceType" label="维护类型" labelCol="1" fieldCol="11" dictionary="maintainType" disabled="true"/>
            </div>
        </div>
        <x:title title="物品总体内容" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="genericName" label="通用品名" labelCol="1" fieldCol="2"/>
                <x:inputC name="applicableStandard" label="适用标准" labelCol="1" fieldCol="2"/>
                <x:selectC name="baseUnit" label="基本计量单位" labelCol="1" fieldCol="2" dictionary="measuringUnit"/>
                <x:inputC name="specifications" label="规格" labelCol="1" fieldCol="2"/>
                <x:inputC name="material" label="材质" labelCol="1" fieldCol="2"/>
                <x:inputC name="design" label="版式" labelCol="1" fieldCol="2"/>
                <x:inputC name="size" label="尺码" labelCol="1" fieldCol="2"/>
                <x:inputC name="brand" label="品牌" labelCol="1" fieldCol="2"/>
                <x:selectC name="itemAttributes" label="物品属性" labelCol="1" fieldCol="2" dictionary="suppliesType"/>
                <x:inputC name="materialUsage" label="用途" labelCol="1" fieldCol="8"/>

            </div>
        </div>

        <x:title title="维护MRP信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="werksName" label="工厂" labelCol="1" fieldCol="2"/>
                <x:selectC name="disgr" label="MRP组" labelCol="1" fieldCol="2" dictionary="disgr"/>
                <x:selectC name="dismm" label="MRP类型" labelCol="1" fieldCol="2" dictionary="dismm"/>
                <x:selectC name="dismm" label="MRP类型" labelCol="1" fieldCol="2" dictionary="dismm"/>
                <x:inputC name="minbe" label="重订货点" labelCol="1" fieldCol="2"/>
                <x:inputC name="dispo" label="MRP控制者" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="disls" label="批量规模" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="bstfe" label="固定批量" labelCol="1" fieldCol="2"/>
                <x:inputC name="bstma" label="最大批量" labelCol="1" fieldCol="2"/>
                <x:inputC name="bstmi" label="最小批量" labelCol="1" fieldCol="2"/>
                <x:inputC name="mabst" label="最大存货水平" labelCol="1" fieldCol="2"/>
                <x:inputC name="bstrf" label="设入值" labelCol="1" fieldCol="2"/>
                <x:selectC name="beskz" label="获取类型" labelCol="1" fieldCol="2" dictionary="beskz"/>
                <x:inputC name="sobsl" label="特殊获取方式" labelCol="1" fieldCol="2"/>
                <x:inputC name="lgproName" label="默认生产库存地" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="lgpro"/>
                <x:selectC name="rgekz" label="倒冲标志" labelCol="1" fieldCol="2" dictionary="rgekz"/>
                <x:inputC name="lgfsbName" label="默认采购收货库存地" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="lgfsb"/>
                <x:inputC name="webaz" label="收货处理天数" labelCol="1" fieldCol="2"/>
                <x:inputC name="dzeit" label="自制时间" labelCol="1" fieldCol="2"/>
                <x:inputC name="plifz" label="外部采购交货时间" labelCol="1" fieldCol="2"/>
                <x:inputC name="fhori" label="排程边际码" labelCol="1" fieldCol="2" required="false"/>
                <x:inputC name="eisbe" label="安全库存" labelCol="1" fieldCol="2"/>
                <x:inputC name="eislo" label="最小安全库存" labelCol="1" fieldCol="2"/>
                <x:selectC name="strgr" label="策略组" labelCol="1" fieldCol="2" dictionary="strgr"/>
                <x:inputC name="mtvfp" label="可用性检查组" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="wzeit" label="补货提前天数" labelCol="1" fieldCol="2"/>
                <x:selectC name="sbdkz" label="独立/集中" labelCol="1" fieldCol="2" dictionary="sbdkz"/>
                <x:selectC name="diskz" label="库存地MRP标识" labelCol="1" fieldCol="2" dictionary="diskz"/>

            </div>
        </div>

        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:hidden name="businessUsage"/>
                <x:checkboxListC name="businessUsage" label="业务用途" dictionary="serviceusage" labelCol="1"
                                 fieldCol="11" disabled="true"/>
            </div>
            <div class="hg-form-row" id="businessPersonnelList">
                <x:title title="业务人员" name="group"/>
                <div id="businessPersonnelListGrid" style="margin: 2px;"></div>
            </div>
        </div>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:textareaC rows="3" name="textDescription" label="文本说明" labelCol="1" fieldCol="11"/>
            </div>
        </div>


    </form>
    <form class="hg-form" method="post" action="" style="display: none;" id="auditForm">
        <div class=" border-left-top" style="margin-top: 10px;">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <span>部门数据审核</span>
                </div>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:checkboxListC name="auditDept" label="驳回部门" list="auditDeptMap" labelCol="2"
                                         fieldCol="10"/>
                    </div>
                    <div id="rejectReasonBox"></div>
                    <div style="text-align: center">
                        <div class="btn-group" style="margin: 15px 0px 15px 0px;">
                            <button id="reject" title="" type="button" onclick="rejectForm()" class="btn btn-gray"><i
                                    class="fa fa-reply"></i>驳回
                            </button>
                            <button id="exPass" title="" type="button" class="btn btn-gray"><i
                                    class="fa fa-mail-forward"></i>检查通过
                            </button>
                            <button id="send" title="" type="button" onclick="distributeForm()"
                                    class="btn btn-gray"><i
                                    class="fa fa-send-o"></i>传输
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
    <div class="blank_div clearfix" ></div>
</div>

</body>
</html>
