<%@ page language="java" contentType="text/html; charset=utf-8" %>
<%@taglib uri="/WEB-INF/taglib.tld" prefix="x" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<html>
<head>
    <x:base include="layout,dialog,grid,tree,combox,commonTree,date"/>
    <x:script src='/biz/topsun/sap/nonProdApply/nonProdApplyMass.js'/>
</head>

<body>
<x:hidden name="isDetailPage" value="false"/> <!--是否是详情页-->
<x:hidden name="deptCode" value="false"/> <!--是否是详情页-->

<div class="container-fluid" style="padding: 10px;">
    <x:billTitle title="非产品/非本成品类物料质量信息维护" needStatus="false" needPerson="true"/>

    <form class="hg-form" method="post" action="" id="submitForm">
        <x:hidden name="active"/> <!--状态-->
        <x:hidden name="meId"/> <!--状态-->
        <div style="float: right; margin-right: 10px;display: none;" class="btn-group" id="buttonBox">
            <button id="save" title="" type="button" onclick="saveForm(0)" class="btn btn-gray"><i
                    class="fa fa-save"></i>保存
            </button>
            <button id="submit" title="" type="button" onclick="saveForm(1)" class="btn btn-gray"><i
                    class="fa fa-save"></i>提交
            </button>
            <button id="back" title="" type="button" onclick="clearForm()" class="btn btn-gray"><i
                    class="fa fa-reply"></i>撤销
            </button>
            <button id="showChart" title="" type="button" onclick="distributeForm()" class="btn btn-gray"><i
                    class="fa fa-sitemap"></i>分发
            </button>
        </div>
        <br/>

        <div class=" border-left-top" style="margin-top: 20px;display: none;" id="causeBox">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <h4>驳回历史</h4>
                </div>
                <div class="hg-form-cols" id="cause-details-box"></div>
            </div>
        </div>

        <x:hidden name="applyDeptId"/>
        <x:hidden name="id"/>
        <x:hidden name="businessCode"/>
        <x:title title="基本信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="billCode" label="申请单编号" labelCol="1" readonly="true" fieldCol="2"/>
                <x:selectC name="statusId" label="批准状态" dictionary="bizBillStatus" disabled="true" labelCol="1"
                           fieldCol="2"/>
                <x:inputC name="personMemberName" label="填写人" readonly="true" labelCol="1" fieldCol="2"/>
                <x:inputC name="fillinDate" label="填写日期" readonly="true" wrapper="date" labelCol="1" fieldCol="2"/>
            </div>
            <div class="hg-form-row">
                <x:radioC name="maintenanceType" label="维护类型" labelCol="1" fieldCol="11" dictionary="maintainType" disabled="true"/>
            </div>
        </div>
        <x:title title="物品总体内容" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="genericName" label="通用品名" labelCol="1" fieldCol="2"/>
                <x:inputC name="applicableStandard" label="适用标准" labelCol="1" fieldCol="2"/>
                <x:selectC name="baseUnit" label="基本计量单位" labelCol="1" fieldCol="2" dictionary="measuringUnit"/>
                <x:inputC name="specifications" label="规格" labelCol="1" fieldCol="2"/>
                <x:inputC name="material" label="材质" labelCol="1" fieldCol="2"/>
                <x:inputC name="design" label="版式" labelCol="1" fieldCol="2"/>
                <x:inputC name="size" label="尺码" labelCol="1" fieldCol="2"/>
                <x:inputC name="brand" label="品牌" labelCol="1" fieldCol="2"/>
                <x:selectC name="itemAttributes" label="物品属性" labelCol="1" fieldCol="2" dictionary="suppliesType"/>
                <x:inputC name="materialUsage" label="用途" labelCol="1" fieldCol="8"/>

            </div>
        </div>

        <x:title title="维护质量信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="werks" label="工厂" labelCol="1" fieldCol="2"/>
                <x:inputC name="kzdkz" label="文档要求" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="art" label="检验类型" labelCol="1" fieldCol="2" required="true"/>
                <x:selectC name="aktiv" label="激活标识" labelCol="1" fieldCol="2" dictionary="suppliesType" required="true"/>
                <x:inputC name="insmk" label="过账到质检" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="ppl" label="带任务清单检验" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="app" label="自动分配" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="mer" label="检查特性" labelCol="1" fieldCol="2" required="true"/>
                <x:inputC name="dyn" label="允许略过" labelCol="1" fieldCol="2" required="true"/>

            </div>
        </div>

        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:hidden name="businessUsage"/>
                <x:checkboxListC name="businessUsage" label="业务用途" dictionary="serviceusage" labelCol="1"
                                 fieldCol="11" disabled="true"/>
            </div>
            <div class="hg-form-row" id="businessPersonnelList">
                <x:title title="业务人员" name="group"/>
                <div id="businessPersonnelListGrid" style="margin: 2px;"></div>
            </div>
        </div>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:textareaC rows="3" name="textDescription" label="文本说明" labelCol="1" fieldCol="11"/>
            </div>
        </div>

        <%--        <x:title title="分类" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="klart" label="类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="classify" label="分类" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>
        <%--        <x:title title="销售" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="vkorg" label="销售组织" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="vtweg" label="分销渠道" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="vrkme" label="销售计量单位" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="umren" label="转换分母" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="umrez" label="转换分子" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="dwerk" label="交货工厂" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="aland" label="税收发运国" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="taxkm" label="税分类" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="versg" label="统计组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="kondm" label="物料定价组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="ktgrm" label="会计科目组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="prodh" label="产品层级" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mvgr1" label="版式" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mvgr2" label="品牌" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mvgr3" label="用途" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mvgr4" label="备用" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mvgr5" label="备用" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mtpos" label="销售项次组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="tragr" label="运输组" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>
        <%--        <x:title title="采购" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="bstme" label="采购计量单位" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="umrenPurch" label="转换分母" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="umrezPurch" label="转换分子" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="ekgrp" label="默认采购组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mprof" label="MPN参数" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>

        <%--        <x:title title="MRP" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="lgort" label="库存地点" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="disgr" label="MRP组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="dismm" label="MRP类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="minbe" label="重订货点" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="dispo" label="MRP控制者" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="disls" label="批量规模" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="bstfe" label="固定批量" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="bstma" label="最大批量" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="bstmi" label="最小批量" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mabst" label="最大存货水平" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="bstrf" label="设入值" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="beskz" label="获取类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="sobsl" label="特殊获取方式" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lgpro" label="默认生产库存地" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="rgekz" label="倒冲标志" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lgfsb" label="默认采购收货库存地" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="webaz" label="收货处理天数" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="dzeit" label="自制时间" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="plifz" label="外部采购交货时间" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="fhori" label="排程边际码" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="eisbe" label="安全库存" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="eislo" label="最小安全库存" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="strgr" label="策略组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mtvfp" label="可用性检查组" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="wzeit" label="补货提前天数" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="altsl" label="BOM选择方法" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="sbdkz" label="独立/集中" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="diskz" label="库存地MRP标识" labelCol="1" fieldCol="2"/>--%>

        <%--            </div>--%>
        <%--        </div>--%>

        <%--        <x:title title="生产" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="ausme" label="投料计量单位" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="umrenProd" label="转换分母（生产）" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="umrezProd" label="转换分子（生产）" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="sfcpf" label="生产计划参数文件" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="insmk" label="过账到质检" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>

        <%--        <x:title title="存储管理" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="lgortQm" label="库存地点" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="sernp" label="序列号参数" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="serlv" label="序列号水平" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="prctr" label="利润中心" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>

        <%--        <x:title title="仓库管理" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="lgortProfit" label="库存地点" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lgnum" label="仓库号" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lgtyp" label="存储类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="ltkza" label="存货下架存储类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="ltkze" label="存货上架存储类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lgbkz" label="存储分区标识" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lhmg1" label="仓库设施1存储数量" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lhme1" label="仓库设施1存储单位" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="lety1" label="仓库设施1类型" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>

        <%--        <x:title title="质量管理" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="kzdkz" label="文档要求" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="art" label="检验类型" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="aktiv" label="激活标识" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="insmkQm" label="过账到质检（质检）" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="aktiv" label="激活标识" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="ppl" label="带任务清单检验" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="app" label="自动分配" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mer" label="检查特性" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="dyn" label="允许略过" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>

        <%--        <x:title title="财务核算" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="bklas" label="评估分类" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="mlast" label="价格确定" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="vprsv" label="价格控制" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="peinh" label="定价基数" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="verpr" label="移动平均价" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="stprs" label="标准价" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>
        <%--        <x:title title="成本核算" name="group"/>--%>
        <%--        <div class="hg-form-cols">--%>
        <%--            <div class="hg-form-row">--%>
        <%--                <x:inputC name="ekalr" label="数量结构" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="ncost" label="不参与成本核算" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="hkmat" label="物料来源" labelCol="1" fieldCol="2"/>--%>
        <%--                <x:inputC name="awsls" label="差异码" labelCol="1" fieldCol="2"/>--%>
        <%--            </div>--%>
        <%--        </div>--%>
    </form>
    <form class="hg-form" method="post" action="" style="display: none;" id="auditForm">
        <div class=" border-left-top" style="margin-top: 10px;">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <span>部门数据审核</span>
                </div>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:checkboxListC name="auditDept" label="驳回部门" list="auditDeptMap" labelCol="2"
                                         fieldCol="10"/>
                    </div>
                    <div id="rejectReasonBox"></div>
                    <div style="text-align: center">
                        <div class="btn-group" style="margin: 15px 0px 15px 0px;">
                            <button id="reject" title="" type="button" onclick="rejectForm()" class="btn btn-gray"><i
                                    class="fa fa-reply"></i>驳回
                            </button>
                            <button id="exPass" title="" type="button" class="btn btn-gray"><i
                                    class="fa fa-mail-forward"></i>检查通过
                            </button>
                            <button id="send" title="" type="button" onclick="distributeForm()"
                                    class="btn btn-gray"><i
                                    class="fa fa-send-o"></i>传输
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
    <div class="blank_div clearfix" ></div>
</div>

</body>
</html>
