<%@ page language="java" contentType="text/html; charset=utf-8" %>
<%@taglib uri="/WEB-INF/taglib.tld" prefix="x" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<html>
<head>
    <x:base include="layout,dialog,grid,tree,combox,commonTree,date"/>
    <x:script src='/biz/topsun/sap/nonProdApply/nonProdApplyNext.js'/>
</head>

<body>
<x:hidden name="isDetailPage" value="false"/> <!--是否是详情页-->
<x:hidden name="deptCode" value="false"/> <!--是否是详情页-->

<div class="container-fluid" style="padding: 10px;">
    <x:billTitle title="非产品/非本成品类物料基本信息维护" needStatus="false" needPerson="true"/>

    <form class="hg-form" method="post" action="" id="submitForm">
        <x:hidden name="active" value=""/> <!--状态-->
        <x:hidden name="meId" value=""/> <!--状态-->
        <x:hidden name="status" /> <!--状态-->
        <div style="float: right; margin-right: 10px;display: none;" class="btn-group" id="buttonBox">
            <button id="save" title="" type="button" onclick="saveForm()" class="btn btn-gray"><i
                    class="fa fa-save"></i>保存
            </button>
            <button id="back" title="" type="button" onclick="clearForm()" class="btn btn-gray"><i
                    class="fa fa-reply"></i>撤销
            </button>
            <button id="showChart" title="" type="button" onclick="distributeForm()" class="btn btn-gray"><i
                    class="fa fa-sitemap"></i>分发
            </button>
        </div>
        <br/>

        <div class=" border-left-top" style="margin-top: 20px;display: none;" id="causeBox">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <h4>驳回历史</h4>
                </div>
                <div class="hg-form-cols" id="cause-details-box"></div>
            </div>
        </div>

        <x:hidden name="applyDeptId"/>
        <x:hidden name="id"/>
        <x:hidden name="businessCode"/>
        <x:title title="基本信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="billCode" label="申请单编号" labelCol="1" readonly="true" fieldCol="2"/>
                <x:selectC name="statusId" label="批准状态" dictionary="bizBillStatus" disabled="true" labelCol="1"
                           fieldCol="2"/>
                <x:inputC name="personMemberName" label="填写人" readonly="true" labelCol="1" fieldCol="2"/>
                <x:inputC name="fillinDate" label="填写日期" readonly="true" wrapper="date" labelCol="1" fieldCol="2"/>
            </div>
            <div class="hg-form-row">
                <x:radioC name="maintenanceType" label="维护类型" labelCol="1" fieldCol="11" dictionary="maintainType"/>
            </div>
        </div>
        <x:title title="物品总体内容" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="genericName" label="通用品名" labelCol="1" fieldCol="2"/>
                <x:inputC name="applicableStandard" label="适用标准" labelCol="1" fieldCol="2"/>
                <x:selectC name="baseUnit" label="基本计量单位" labelCol="1" fieldCol="2" dictionary="measuringUnit"/>
                <x:inputC name="specifications" label="规格" labelCol="1" fieldCol="2"/>
                <x:inputC name="material" label="材质" labelCol="1" fieldCol="2"/>
                <x:inputC name="design" label="版式" labelCol="1" fieldCol="2"/>
                <x:inputC name="size" label="尺码" labelCol="1" fieldCol="2"/>
                <x:inputC name="brand" label="品牌" labelCol="1" fieldCol="2"/>
                <x:selectC name="itemAttributes" label="物品属性" labelCol="1" fieldCol="2" dictionary="suppliesType"/>
                <x:inputC name="materialUsage" label="用途" labelCol="1" fieldCol="8"/>

            </div>
        </div>
        <x:title title="维护基本信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="matnr" label="物品编码" labelCol="1" fieldCol="2"/>
                <x:selectC name="mtart" label="物品类型" required="true" labelCol="1" fieldCol="2" dictionary="suppliesType"/>
                <x:inputC name="matklName" label="物料组" required="true" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="matkl"/>
                <x:inputC name="lvorm" label="集团级删除" labelCol="1" fieldCol="2"/>
                <x:inputC name="spartName" label="产品组" required="true" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="spart"/>
                <x:selectC name="mtposMara" label="项目类别组" labelCol="1" fieldCol="2" dictionary="mtposMara"/>
                <x:inputC name="maktx" label="汉语品名" required="true" labelCol="1" fieldCol="2"/>
                <x:inputC name="xchpf" label="批次管理" labelCol="1" fieldCol="2"/>
                <x:inputC name="magrv" label="包装物料组" labelCol="1" fieldCol="2"/>

                <x:inputC name="maktxEn" label="英语品名" labelCol="1" fieldCol="2"/>
                <x:inputC name="meinsName" label="基本计量单位" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="meins"/>
                <x:inputC name="raube" label="存储条件" required="true" labelCol="1" fieldCol="2"/>
                <x:inputC name="brgew" label="毛重" labelCol="1" fieldCol="2"/>
                <x:selectC name="gewei" label="重量单位" labelCol="1" fieldCol="2" dictionary="gewei"/>
                <x:inputC name="volum" label="体积" labelCol="1" fieldCol="2"/>
                <x:selectC name="voleh" label="体积单位" labelCol="1" fieldCol="2" dictionary="voleh"/>
                <x:inputC name="iprkz" label="有效时间标识" labelCol="1" fieldCol="2"/>
                <x:inputC name="mhdhb" label="总有效期" labelCol="1" fieldCol="2"/>
                <x:inputC name="" label="旧料号" labelCol="1" fieldCol="2"/>

                <x:inputC name="mhdrz" label="最小货架寿命" labelCol="1" fieldCol="2"/>
                <x:inputC name="normt" label="适用标准" labelCol="1" fieldCol="11"/>
                <div class="hg-form-row">
                <x:inputC name="werksName" label="工厂" required="true" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="werks"/>
                <x:inputC name="lgortName" label="库存地点" required="true" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="lgort"/>
                <x:inputC name="vkorgName" required="true" label="销售组织" labelCol="1" wrapper="select" fieldCol="2"/>
                <x:hidden name="vkorg"/>
                <x:inputC name="vtwegName" required="true" label="分销渠道" labelCol="1" wrapper="select" fieldCol="2"/>
                <x:hidden name="vtweg"/>
                <x:inputC name="lgnumName" label="仓库号" required="true" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="lgnum"/>
                <x:inputC name="lgtypName" label="存储类型" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="lgtyp"/>
                </div>
                <div class="hg-form-row">
                    <x:inputC name="klart" label="类型" labelCol="1" fieldCol="2" readonly="true"/>
                    <x:inputC name="classify" label="分类" labelCol="1" fieldCol="2" readonly="true"/>
                </div>
            </div>
        </div>

        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:hidden name="businessUsage"/>
                <x:checkboxListC name="businessUsage" label="业务用途" dictionary="serviceusage" labelCol="1"
                                 fieldCol="11"/>
            </div>
            <div class="hg-form-row">
                <x:title title="业务人员" name="group"/>
                <div id="businessPersonnelListGrid" style="margin: 2px;"></div>
            </div>
        </div>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:textareaC rows="3" name="textDescription" label="文本说明" labelCol="1" fieldCol="11"/>
            </div>
        </div>
            <div id="businessUsageDiv">
<%--                <x:title title="分类" name="group"/>--%>
<%--                <div class="hg-form-cols">--%>
<%--                    <div class="hg-form-row">--%>
<%--                        <x:inputC name="klart" label="类型" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="classify" label="分类" labelCol="1" fieldCol="2"/>--%>
<%--                    </div>--%>
<%--                </div>--%>
                <x:title title="销售" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="vkorgName" label="销售组织" labelCol="1" fieldCol="2"/>
                        <x:inputC name="vtwegName" label="分销渠道" labelCol="1" fieldCol="2"/>
                        <x:inputC name="vrkmeName" label="销售计量单位" labelCol="1" fieldCol="2"/>
                        <x:inputC name="umrenSale" label="转换分母" labelCol="1" fieldCol="2"/>
                        <x:inputC name="umrezSale" label="转换分子" labelCol="1" fieldCol="2"/>
                        <x:inputC name="dwerk" label="交货工厂" labelCol="1" fieldCol="2"/>
                        <x:inputC name="aland" label="税收发运国" labelCol="1" fieldCol="2"/>
                        <x:selectC name="taxkm" label="税分类" labelCol="1" fieldCol="2" required="true" dictionary="taxkm"/>
                        <x:selectC name="versg" label="统计组" labelCol="1" fieldCol="2" dictionary="versg"/>
                        <x:selectC name="kondm" label="物料定价组" labelCol="1" fieldCol="2" dictionary="kondm"/>
                        <x:selectC name="ktgrm" label="会计科目组" labelCol="1" fieldCol="2" required="true" dictionary="ktgrm"/>
                        <x:inputC name="prodh" label="产品层级" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mvgr1" label="版式" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mvgr2" label="品牌" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mvgr3" label="用途" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mvgr4" label="备用" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mvgr5" label="备用" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mtpos" label="销售项次组" labelCol="1" fieldCol="2"/>
                        <x:inputC name="xchpf" label="批次管理" labelCol="1" fieldCol="2" />
                        <x:inputC name="tragr" label="运输组" labelCol="1" fieldCol="2"/>
                        <x:inputC name="ladgr" label="装载组" labelCol="1" fieldCol="2" required="false"/>
                    </div>
                </div>
                <x:title title="采购" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="bstme" label="采购计量单位" labelCol="1" fieldCol="2"/>
                        <x:inputC name="umrenPurch" label="转换分母" labelCol="1" fieldCol="2"/>
                        <x:inputC name="umrezPurch" label="转换分子" labelCol="1" fieldCol="2"/>
                        <x:inputC name="ekgrpName" label="默认采购组" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mprof" label="MPN参数" labelCol="1" fieldCol="2"/>
                    </div>
                </div>

                <x:title title="MRP" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="lgort" label="库存地点" labelCol="1" fieldCol="2"/>
                        <x:selectC name="disgr" label="MRP组" labelCol="1" fieldCol="2" dictionary="disgr"/>
                        <x:selectC name="dismm" label="MRP类型" labelCol="1" fieldCol="2" dictionary="dismm"/>
                        <x:inputC name="minbe" label="重订货点" labelCol="1" fieldCol="2"/>
                        <x:inputC name="dispo" label="MRP控制者" labelCol="1" fieldCol="2"/>
                        <x:inputC name="disls" label="批量规模" labelCol="1" fieldCol="2"/>
                        <x:inputC name="bstfe" label="固定批量" labelCol="1" fieldCol="2"/>
                        <x:inputC name="bstma" label="最大批量" labelCol="1" fieldCol="2"/>
                        <x:inputC name="bstmi" label="最小批量" labelCol="1" fieldCol="2"/>
                        <x:inputC name="mabst" label="最大存货水平" labelCol="1" fieldCol="2"/>
                        <x:inputC name="bstrf" label="设入值" labelCol="1" fieldCol="2"/>
                        <x:selectC name="beskz" label="获取类型" labelCol="1" fieldCol="2" dictionary="beskz"/>
                        <x:inputC name="sobsl" label="特殊获取方式" labelCol="1" fieldCol="2"/>
                        <x:inputC name="lgpro" label="默认生产库存地" labelCol="1" fieldCol="2"/>
                        <x:selectC name="rgekz" label="倒冲标志" labelCol="1" fieldCol="2" dictionary="rgekz"/>
                        <x:inputC name="lgfsb" label="默认采购收货库存地" labelCol="1" fieldCol="2"/>
                        <x:inputC name="webaz" label="收货处理天数" labelCol="1" fieldCol="2"/>
                        <x:inputC name="dzeit" label="自制时间" labelCol="1" fieldCol="2"/>
                        <x:inputC name="plifz" label="外部采购交货时间" labelCol="1" fieldCol="2"/>
                        <x:inputC name="fhori" label="排程边际码" labelCol="1" fieldCol="2"/>
                        <x:inputC name="eisbe" label="安全库存" labelCol="1" fieldCol="2"/>
                        <x:inputC name="eislo" label="最小安全库存" labelCol="1" fieldCol="2"/>
                        <x:selectC name="strgr" label="策略组" labelCol="1" fieldCol="2" dictionary="strgr"/>
                        <x:inputC name="mtvfp" label="可用性检查组" labelCol="1" fieldCol="2"/>
                        <x:inputC name="wzeit" label="补货提前天数" labelCol="1" fieldCol="2"/>
                        <x:inputC name="altsl" label="BOM选择方法" labelCol="1" fieldCol="2"/>
                        <x:selectC name="sbdkz" label="独立/集中" labelCol="1" fieldCol="2" dictionary="sbdkz"/>
                        <x:selectC name="diskz" label="库存地MRP标识" labelCol="1" fieldCol="2" dictionary="diskz"/>

                    </div>
                </div>

                <x:title title="生产" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="ausme" label="投料计量单位" labelCol="1" fieldCol="2"/>
                        <x:inputC name="umrenProd" label="转换分母（生产）" labelCol="1" fieldCol="2"/>
                        <x:inputC name="umrezProd" label="转换分子（生产）" labelCol="1" fieldCol="2"/>
                        <x:selectC name="sfcpf" label="生产计划参数文件" labelCol="1" fieldCol="2" dictionary="sfcpf"/>
                        <x:selectC name="insmk" label="过账到质检" labelCol="1" fieldCol="2" dictionary="insmk"/>
                    </div>
                </div>

                <x:title title="存储管理" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="lgortQmName" label="库存地点" labelCol="1" fieldCol="2" wrapper="select"/>
                        <x:hidden name="lgortQm"/>
                        <x:inputC name="sernp" label="序列号参数" labelCol="1" fieldCol="2"/>
                        <x:inputC name="serlv" label="序列号水平" labelCol="1" fieldCol="2"/>
                        <x:selectC name="prctr" label="利润中心" labelCol="1" fieldCol="2" dictionary="PRCTR"/>
                    </div>
                </div>

                <x:title title="仓库管理" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="lgortProfitName" label="库存地点" labelCol="1" fieldCol="2" wrapper="select"/>
                        <x:hidden name="lgortProfit"/>
                        <x:selectC name="lgnum" label="仓库号" labelCol="1" fieldCol="2" dictionary="lgnum"/>
                        <x:inputC name="lgtypName" label="存储类型" labelCol="1" fieldCol="2"/>
                        <x:inputC name="ltkza" label="存货下架存储类型" labelCol="1" fieldCol="2"/>
                        <x:inputC name="ltkze" label="存货上架存储类型" labelCol="1" fieldCol="2"/>
                        <x:inputC name="lgbkz" label="存储分区标识" labelCol="1" fieldCol="2"/>
                        <x:inputC name="lhmg1" label="仓库设施1存储数量" labelCol="1" fieldCol="2"/>
                        <x:inputC name="lhme1Name" label="仓库设施1存储单位" labelCol="1" fieldCol="2" wrapper="select"/>
                        <x:hidden name="lhme1"/>
                        <x:inputC name="lety1" label="仓库设施1类型" labelCol="1" fieldCol="2"/>
                    </div>
                </div>

<%--                <x:title title="质量管理" name="group"/>--%>
<%--                <div class="hg-form-cols">--%>
<%--                    <div class="hg-form-row">--%>
<%--                        <x:inputC name="kzdkz" label="文档要求" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="art" label="检验类型" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="aktiv" label="激活标识" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="insmkQm" label="过账到质检（质检）" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="aktiv" label="激活标识" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="ppl" label="带任务清单检验" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="app" label="自动分配" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="mer" label="检查特性" labelCol="1" fieldCol="2"/>--%>
<%--                        <x:inputC name="dyn" label="允许略过" labelCol="1" fieldCol="2"/>--%>
<%--                    </div>--%>
<%--                </div>--%>

                <x:title title="财务核算" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:selectC name="bklas" label="评估分类" labelCol="1" fieldCol="2" dictionary="bklas"/>
                        <x:inputC name="mlast" label="价格确定" labelCol="1" fieldCol="2"/>
                        <x:inputC name="vprsv" label="价格控制" labelCol="1" fieldCol="2"/>
                        <x:inputC name="peinh" label="定价基数" labelCol="1" fieldCol="2"/>
                        <x:inputC name="verpr" label="移动平均价" labelCol="1" fieldCol="2"/>
                        <x:inputC name="stprs" label="标准价" labelCol="1" fieldCol="2"/>
                    </div>
                </div>
                <x:title title="成本核算" name="group"/>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:inputC name="ekalr" label="数量结构" labelCol="1" fieldCol="2"/>
                        <x:inputC name="ncost" label="不参与成本核算" labelCol="1" fieldCol="2"/>
                        <x:inputC name="hkmat" label="物料来源" labelCol="1" fieldCol="2"/>
                        <x:inputC name="awsls" label="差异码" labelCol="1" fieldCol="2"/>
                    </div>
                </div>
            </div>
    </form>
    <form class="hg-form" method="post" action="" style="display: none;" id="auditForm">
        <div class=" border-left-top" style="margin-top: 10px;">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <span>部门数据审核</span>
                </div>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:checkboxListC name="auditDept" label="驳回部门" list="auditDeptMap" labelCol="2"
                                         fieldCol="10"/>
                    </div>
                    <div id="rejectReasonBox"></div>
                    <div style="text-align: center">
                        <div class="btn-group" style="margin: 15px 0px 15px 0px;">
                            <button id="reject" title="" type="button" onclick="rejectForm()" class="btn btn-gray"><i
                                    class="fa fa-reply"></i>驳回
                            </button>
                            <button id="exPass" title="" type="button" class="btn btn-gray"><i
                                    class="fa fa-mail-forward"></i>检查通过
                            </button>
                            <button id="send" title="" type="button" onclick="distributeForm()"
                                    class="btn btn-gray"><i
                                    class="fa fa-send-o"></i>传输
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
    <div class="blank_div clearfix" ></div>
</div>

</body>
</html>
