<%@ page language="java" contentType="text/html; charset=utf-8" %>
<%@taglib uri="/WEB-INF/taglib.tld" prefix="x" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<html>
<head>
    <x:base include="layout,dialog,grid,tree,combox,commonTree,date"/>
    <x:script src='/biz/topsun/sap/nonProdApply/nonProdApplySale.js'/>
</head>

<body>
<x:hidden name="isDetailPage" value="false"/> <!--是否是详情页-->
<x:hidden name="deptCode" value="false"/> <!--是否是详情页-->

<div class="container-fluid" style="padding: 10px;">
    <x:billTitle title="非产品/非本成品类物料销售信息维护" needStatus="false" needPerson="true"/>

    <form class="hg-form" method="post" action="" id="submitForm">
        <x:hidden name="active"/> <!--状态-->
        <x:hidden name="meId"/> <!--状态-->
        <div style="float: right; margin-right: 10px;display: none;" class="btn-group" id="buttonBox">
            <button id="save" title="" type="button" onclick="saveForm(0)" class="btn btn-gray"><i
                    class="fa fa-save"></i>保存
            </button>
            <button id="submit" title="" type="button" onclick="saveForm(1)" class="btn btn-gray"><i
                    class="fa fa-save"></i>提交
            </button>
            <button id="back" title="" type="button" onclick="clearForm()" class="btn btn-gray"><i
                    class="fa fa-reply"></i>撤销
            </button>
            <button id="showChart" title="" type="button" onclick="distributeForm()" class="btn btn-gray"><i
                    class="fa fa-sitemap"></i>分发
            </button>
        </div>
        <br/>

        <div class=" border-left-top" style="margin-top: 20px;display: none;" id="causeBox">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <h4>驳回历史</h4>
                </div>
                <div class="hg-form-cols" id="cause-details-box"></div>
            </div>
        </div>

        <x:hidden name="applyDeptId"/>
        <x:hidden name="id"/>
        <x:hidden name="businessCode"/>
        <x:title title="基本信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="billCode" label="申请单编号" labelCol="1" readonly="true" fieldCol="2"/>
                <x:selectC name="statusId" label="批准状态" dictionary="bizBillStatus" disabled="true" labelCol="1"
                           fieldCol="2"/>
                <x:inputC name="personMemberName" label="填写人" readonly="true" labelCol="1" fieldCol="2"/>
                <x:inputC name="fillinDate" label="填写日期" readonly="true" wrapper="date" labelCol="1" fieldCol="2"/>
            </div>
            <div class="hg-form-row">
                <x:radioC name="maintenanceType" label="维护类型" labelCol="1" fieldCol="11" dictionary="maintainType" disabled="true"/>
            </div>
        </div>
        <x:title title="物品总体内容" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:inputC name="genericName" label="通用品名" labelCol="1" fieldCol="2"/>
                <x:inputC name="applicableStandard" label="适用标准" labelCol="1" fieldCol="2"/>
                <x:selectC name="baseUnit" label="基本计量单位" labelCol="1" fieldCol="2" dictionary="measuringUnit"/>
                <x:inputC name="specifications" label="规格" labelCol="1" fieldCol="2"/>
                <x:inputC name="material" label="材质" labelCol="1" fieldCol="2"/>
                <x:inputC name="design" label="版式" labelCol="1" fieldCol="2"/>
                <x:inputC name="size" label="尺码" labelCol="1" fieldCol="2"/>
                <x:inputC name="brand" label="品牌" labelCol="1" fieldCol="2"/>
                <x:selectC name="itemAttributes" label="物品属性" labelCol="1" fieldCol="2" dictionary="suppliesType"/>
                <x:inputC name="materialUsage" label="用途" labelCol="1" fieldCol="8"/>

            </div>
        </div>

        <x:title title="维护销售信息" name="group"/>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:selectC name="vkorg" required="false" label="销售组织" labelCol="1" dictionary="vkorg" fieldCol="2"/>
                <x:inputC name="vtwegName" required="false" label="分销渠道" labelCol="1" fieldCol="2" wrapper="select"/>
                <x:hidden name="vtweg"/>
                <x:selectC name="vrkme" label="销售计量单位" labelCol="1" fieldCol="2" dictionary="measuringUnit"/>
                <x:inputC name="umrenSale" label="转换分母" labelCol="1" fieldCol="2"/>
                <x:inputC name="umrezSale" label="转换分子" labelCol="1" fieldCol="2"/>
                <x:inputC name="dwerk" label="交货工厂" labelCol="1" fieldCol="2"/>
                <x:inputC name="aland" label="税收发运国" labelCol="1" fieldCol="2" required="true"/>
                <x:selectC name="taxkm" label="税分类" labelCol="1" fieldCol="2" required="true" dictionary="taxkm"/>
                <x:selectC name="versg" label="统计组" labelCol="1" fieldCol="2" dictionary="versg"/>
                <x:selectC name="kondm" label="物料定价组" labelCol="1" fieldCol="2" dictionary="kondm"/>
                <x:selectC name="ktgrm" label="会计科目组" labelCol="1" fieldCol="2" required="true" dictionary="ktgrm"/>
                <%--<x:selectC name="prodh" label="产品层级" labelCol="1" fieldCol="2" dictionary="productLevels"/>--%>
                <x:inputC name="prodh" label="产品层级" labelCol="1" fieldCol="2"/>
                <x:inputC name="mvgr1" label="版式" labelCol="1" fieldCol="2"/>
                <x:inputC name="mvgr2" label="品牌" labelCol="1" fieldCol="2"/>
                <x:inputC name="mvgr3" label="用途" labelCol="1" fieldCol="2"/>
                <x:inputC name="mvgr4" label="备用" labelCol="1" fieldCol="2"/>
                <x:inputC name="mvgr5" label="备用" labelCol="1" fieldCol="2"/>
                <x:inputC name="mtpos" label="销售项次组" labelCol="1" fieldCol="2" required="false"/>
                <x:inputC name="xchpf" label="批次管理" labelCol="1" fieldCol="2" />
                <x:inputC name="tragr" label="运输组" labelCol="1" fieldCol="2" required="false"/>
                <x:inputC name="ladgr" label="装载组" labelCol="1" fieldCol="2" required="false"/>
            </div>
        </div>

        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:hidden name="businessUsage"/>
                <x:checkboxListC name="businessUsage" label="业务用途" dictionary="serviceusage" labelCol="1"
                                 fieldCol="11" disabled="true"/>
            </div>
            <div class="hg-form-row" id="businessPersonnelList">
                <x:title title="业务人员" name="group"/>
                <div id="businessPersonnelListGrid" style="margin: 2px;"></div>
            </div>
        </div>
        <div class="hg-form-cols">
            <div class="hg-form-row">
                <x:textareaC rows="3" name="textDescription" label="文本说明" labelCol="1" fieldCol="11"/>
            </div>
        </div>
    </form>
    <form class="hg-form" method="post" action="" style="display: none;" id="auditForm">
        <div class=" border-left-top" style="margin-top: 10px;">
            <div class=" gray-bg">
                <div class="col-xs-2 " style="text-align: center;margin-top: 30px">
                    <span>部门数据审核</span>
                </div>
                <div class="hg-form-cols">
                    <div class="hg-form-row">
                        <x:checkboxListC name="auditDept" label="驳回部门" list="auditDeptMap" labelCol="2"
                                         fieldCol="10"/>
                    </div>
                    <div id="rejectReasonBox"></div>
                    <div style="text-align: center">
                        <div class="btn-group" style="margin: 15px 0px 15px 0px;">
                            <button id="reject" title="" type="button" onclick="rejectForm()" class="btn btn-gray"><i
                                    class="fa fa-reply"></i>驳回
                            </button>
                            <button id="exPass" title="" type="button" class="btn btn-gray"><i
                                    class="fa fa-mail-forward"></i>检查通过
                            </button>
                            <button id="send" title="" type="button" onclick="distributeForm()"
                                    class="btn btn-gray"><i
                                    class="fa fa-send-o"></i>传输
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
    <div class="blank_div clearfix" ></div>
</div>

</body>
</html>
