var gridManager = null;

$(document).ready(function () {
    initialize();
    loadGrid();
    bindEvent();
});
function initialize(){
    UICtrl.layout("#layout", {leftWidth: 3});
    var statusId = $("#statusId").val();
    if (statusId === "0"){
        UICtrl.setElHideOrShow("#bktxt",true)
        UICtrl.setElHideOrShow("#budat",true)
        UICtrl.setElHideOrShow("#paymentMethod",true)
        UICtrl.setElHideOrShow("#totalMoney",true)
    }
}

function bindEvent(){
    
}

function loadGrid() {
    var toolbarOptions = UICtrl.getDefaultToolbarOptions({
        addHandler: function () {
            UICtrl.addGridRow(gridManager,{ sequence: (gridManager.getData().length + 1)});
        },
        deleteHandler: function () {
            var _grid = UICtrl.getGridManager('#maingrid');
            DataUtil.delSelectedRows({
                action: 'wasteSaleItem/deleteWasteSaleItem.ajax',
                param: {},
                gridManager: _grid,
                idFieldName: 'id',
                onSuccess: function () {
                    reloadGrid();
                }
            });
        }
    });
    gridManager = UICtrl.grid("#maingrid", {
        columns: getGridColumns(),
        dataAction: "server",
        url: web_app.name + '/wasteSaleItem/queryWasteSaleItems.ajax',
        pageSize: 10,
        usePager: true,
        parms:{wasteSaleId:getId()},
        toolbar: toolbarOptions,
        enabledEdit: true,
        width: "100%",
        height: "70%",
        heightDiff: -8,
        checkbox: true,
        fixedCellHeight: true,
        selectRowButtonOnly: true,
    });
    UICtrl.setSearchAreaToggle(gridManager);
}

function getGridColumns(){
    var columns=[];
    columns.push({
        display: "序号", name: "sequence", width: 100, minWidth: 60, type: "string", align: "left",
    },)
    columns.push({
        display: "品类", name: "wasteType", width: 200, minWidth: 60, type: "string", align: "left",
        editor: {
            required: true, type: "text"
        }
    },)
    columns.push({
        display: "数量", name: "quantity", width: 200, minWidth: 60, type: "string", align: "left",
        editor: {
            required: true, type: "text",mask: '9999999.99'
        }
    },)
    columns.push({
        display: "计量单位", name: "unitName", width: 200, minWidth: 60, type: "string", align: "left",
        editor: {
            required: true, type: "select",
            data: {
                type: 'system',
                name: "dictionary",
                getParam: function (item) {
                    return {fieldName: "MEINS"}
                },
                back: {
                    MSEHI: "unit",
                    MSEHL: "unitName",
                }
            },
        }
    },)
    var subProcUnitId = getSubProcUnitId();
    var statusId = $("#statusId").val();
    if (subProcUnitId === "purchase" || statusId > 0){
        //采购部专员录入回收单价，自动计算出总价，补充收款账户
        columns.push({
            display: "单价", name: "price", width: 200, minWidth: 60, type: "string", align: "left",
            editor: {
                required: true, type: "text",mask: '9999999.99'
            }
        },)
        columns.push({
            display: "总价", name: "amount", width: 140, minWidth: 60, type: "string", align: "left",
            render: function (item){
                if (Public.isNotBlank(item.quantity) && Public.isNotBlank(item.price)){
                    var amount = MathUtil.mul(item.quantity,item.price)
                    countTotalMoney();
                    return item.amount = amount
                }
            }
        },)
    }
    return columns;
}

/**
 * 流程引擎回调设置打样的id
 * @param value 打样申请的id
 */
function setId(id) {
    $("#id").val(id);

    var _grid=UICtrl.getGridManager('#maingrid');
    _grid.options.parms.wasteSaleId = id;
}

/**
 * 流程引擎获取打样申请id的回掉方法。
 * @return 打样申请的id
 */
function getId() {
    return $("#id").val() || "";
}

function reloadGrid() {
    gridManager.loadData();
}

function getExtendedData(processAction) {
//回退、打回、转交时，不需要验证必填项是否已经填写；
    if (processAction == ProcessAction.BACK
        || processAction == ProcessAction.REPLENISH
        || processAction == ProcessAction.TRANSMIT) {
//不验证
        $('#submitForm').attr('check', false);
    }
    var extendedData = {};
    var _grid = UICtrl.getGridManager('#maingrid');
    if (_grid) {
        var datas = DataUtil.getGridData({
            gridManager: _grid,
            isAllData: true
        });
        if (!datas) {
            return false;
        }
        extendedData.items = Public.encodeJSONURI(datas);
    }
    return extendedData;
}

//UICtrl中校验是否允许编辑
function businessJudgmentUnit() {
    var isApply='';

    if( typeof(isApplyProcUnit) =='function'){
        isApply=isApplyProcUnit();
    }
    if (isApply){
        return true
    }else {
        var subProcUnitId = getSubProcUnitId();
        if (subProcUnitId === "purchase"){
            UICtrl.setEditable($("#submitForm"));
            UICtrl.setElRequiredFlag('#bktxt', true);
            UICtrl.setElRequiredFlag('#budat', true);
            UICtrl.setElRequiredFlag('#paymentMethod', true);
            UICtrl.disable($("#totalMoney"))
            return true
        }
    }
    return false;
}

function countTotalMoney(){
    var datas = gridManager.getData();
    var totalMoney = 0;
    datas.forEach(data =>{
        var amount = MathUtil.mul(data.quantity,data.price);
        totalMoney = MathUtil.add(totalMoney,amount);
        $("#totalMoney").val(totalMoney);
    })
}
