package com.huigou.topsun.sap.common.application.impl;

import cn.hutool.core.bean.BeanUtil;
import com.huigou.topsun.sap.common.application.SapMutualEpLogApplication;
import com.huigou.topsun.sap.common.domain.SapMutualEpLog;
import com.huigou.topsun.sap.common.repository.SapMutualEpLogRepository;
import com.huigou.util.ClassHelper;
import com.huigou.util.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;


@Service("sapMutualEpLogApplication")
public class SapMutualEpLogApplicationImpl implements SapMutualEpLogApplication {

    @Autowired
    SapMutualEpLogRepository sapMutualEpLogRepository;

    @Override
    @Transactional(propagation = Propagation.REQUIRES_NEW)
    public SapMutualEpLog saveSapMutualEpLog(Map<String, Object> map){
        SapMutualEpLog sapMutualEpLog = new SapMutualEpLog();
        try {
           sapMutualEpLog.setBusinessId(map.get("businessId").toString());
            sapMutualEpLog.setBusinessType(map.get("businessType").toString());
            sapMutualEpLog = ClassHelper.fromMap(SapMutualEpLog.class, map);
            //BeanUtil.mapToBean(map, ClassHelpersapMutualEpLog);
            Date date = new Date();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

            sapMutualEpLog.setCreatedDate(sdf.format(date));
            sapMutualEpLogRepository.save(sapMutualEpLog);
        }catch (Exception ex){
            ex.printStackTrace();
        }
        return sapMutualEpLog;
    }
}
