package com.huigou.topsun.sap.costReimbursement.domain.query;


import com.huigou.data.domain.query.QueryAbstractRequest;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 
 * @TableName sap_cost_reimbursement_base_info
 */
@Data
public class SapCostReimbursementQueryRequest extends QueryAbstractRequest {


    /**
     * EP付款申请类别
     */

    private String zepFtype;

    /**
     * EP付款申请类别名称
     */
    private String zepFtypename;

    /**
     * 公司代码
     */
    private String bukrs;

    /**
     * 公司代码名称
     */
    private String butxt;

    /**
     * EP部门代码
     */
    private String zepDepart;

    /**
     * EP部门名称
     */
    private String zepDepartname;

    /**
     * EP流程申请人代码
     */
    private String zepAppli;

    /**
     * EP流程申请人
     */
    private String zepAppliname;

    /**
     * 付款申请创建日期
     */
    private Date zepFcrdate;

    /**
     * EP流程单号
     */
    private String zepNo;

    /**
     * 付款申请内容
     */
    private String zepTxt;

    /**
     * 申请总金额（本位币）
     */
    private BigDecimal zepFtamount;

    /**
     * 申请总税额（本位币）
     */
    private BigDecimal zepFttax;

    /**
     * 申请总金额
     */
    private BigDecimal zepFtamount1;

    /**
     * 申请总税额
     */
    private BigDecimal zepFttax1;

    /**
     * 审批总金额（本位币）
     */
    private BigDecimal zepPtamount;

    /**
     * 审批总税额（本位币）
     */
    private BigDecimal zepPttax;

    /**
     * 审批总金额
     */
    private BigDecimal zepPtamount1;

    /**
     * 审批总税额
     */
    private BigDecimal zepPttax1;

    /**
     * 填报日期
     */
    private Date fillinDate;

}