package com.huigou.topsun.sap.nonProdApply.controller;


import com.huigou.cache.DictUtil;
import com.huigou.topsun.base.bsnMessage.appliction.BsnMessageApplication;
import com.huigou.topsun.base.bsnMessage.domain.ActiveStatus;
import com.huigou.topsun.base.bsnMessage.domain.BsnMessageExecute;
import com.huigou.topsun.base.bsnMessage.domain.BsnMessageReject;
import com.huigou.topsun.base.bsnMessage.domain.BsnMessageSponsor;
import com.huigou.topsun.base.bsnMessage.repository.BsnMessageExecuteRepository;
import com.huigou.topsun.base.bsnMessage.repository.BsnMessageSponsorRepository;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyApplication;
import com.huigou.topsun.sap.nonProdApply.application.NonProdApplyDeptApplication;
import com.huigou.topsun.sap.nonProdApply.domain.NonProdApplyBaseInfo;
import com.huigou.topsun.sap.nonProdApply.domain.SapNonProdApplyDept;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.opm.application.OrgApplication;
import com.huigou.uasp.bmp.opm.domain.model.org.Org;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import com.huigou.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import javax.persistence.Transient;
import java.util.*;
import java.util.stream.Collectors;

@Controller
@ControllerMapping("/sapNonProdApplyNext")
public class NonProdApplyNextController extends CommonController {

    protected String getPagePath() {
        return "/biz/topsun/sap/nonProdApply/";
    }

    @Autowired
    NonProdApplyApplication nonProdApplyApplication;
    @Autowired
    NonProdApplyDeptApplication nonProdApplyDeptApplication;
    @Autowired
    BsnMessageApplication bsnMessageApplication;
    @Autowired
    BsnMessageSponsorRepository bsnMessageSponsorRepository;
    @Autowired
    BsnMessageExecuteRepository bsnMessageExecuteRepository;
    @Autowired
    OrgApplication orgApplication;

    public String forwardNonProdApplyNext() {
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
//        this.putAttribute("active", ActiveStatus.UNFINISHED.getValue() );//定义流程环节的id
        NonProdApplyBaseInfo nonProdApplyBaseInfo = nonProdApplyApplication.loadNonProdApplyBaseInfoById(id);
        SapNonProdApplyDept nonProdApplyDept = nonProdApplyDeptApplication.getNonProdApplyDeptByBaseInfoId(id);
        if (nonProdApplyDept != null) {
            getBaseInfoAttrs(nonProdApplyBaseInfo, nonProdApplyDept);
            return forward("nonProdApplyNext", nonProdApplyDept);
        } else {
            this.putAttribute("active",0);
            return forward("nonProdApplyNext", nonProdApplyBaseInfo);
        }
    }

    //部门相关
    public String slicedDeptList() {
        SDO sdo = this.getSDO();
        String septString = sdo.getString("dept");
//        String applyDeptId = sdo.getString("applyDeptId");
//        List<BsnMessage> bsnMessageAll = bsnMessageApplication.getBsnMessageByBusinessId(applyDeptId);
        List<String> deptList = Arrays.asList(septString.split(","));
        Map<String, String> serviceusage = DictUtil.getDictionary("serviceusage");
        String deptId=sdo.getString("id");
        BsnMessageSponsor sponsor = bsnMessageSponsorRepository.findByBusinessId(deptId);
        List<HashMap<String, String>> list = new ArrayList<>();
        Map<String, List<HashMap<String, String>>> map = new HashMap<>(); // 用于存储结果的字典
        if (sponsor!=null) {
            List<BsnMessageExecute> executeLists = bsnMessageExecuteRepository.findAllByMessageSponsorId(sponsor.getId());
            String businessCode = sdo.getString("businessCode");
            // 用于存储结果的字典
             for (String key : deptList) {
                HashMap<String, String> resultMap = new HashMap<>();
                String value = serviceusage.get(key);
                resultMap.put("deptCode", key);
                resultMap.put("deptName", value);
                for (BsnMessageExecute executor : executeLists) {
                    if (key.equals(executor.getBusinessCode())) {
                        resultMap.put("userCode", executor.getTaskExecute());
                        Org org = orgApplication.loadMainOrgByPersonId(executor.getTaskExecute());
                        resultMap.put("userName", org.getName());
                        break;
                    }
                }
                list.add(resultMap);
            }
       } else {
            for (String key : deptList) {
                HashMap<String, String> resultMap = new HashMap<>();
                String value = serviceusage.get(key);
                resultMap.put("deptCode", key);
                resultMap.put("deptName", value);
                list.add(resultMap);
            }
        }
        map.put("Rows", list);
        return toResult(map);
    }

    /**
     * 添加
     */
    public String saveSapNonProdApplyDept() {
        SDO sdo = this.getSDO();
        Map<String, Object> map = nonProdApplyDeptApplication.saveSapNonProdApplyDept(sdo);
        return toResult(map);
    }


    /**
     * 分发表单
     */
    public String distributeSapNonProdApplyDept() {
        SDO sdo = this.getSDO();
        nonProdApplyDeptApplication.distributeSapNonProdApplyDept(sdo);
        return success();
    }

    /**
     * 填写收到的任务表单
     *
     * @return
     */
    public String fillInNonProdApplyDept() {
        SDO sdo = this.getSDO();
        String bizId = sdo.getBizId();
        String meId = sdo.getString("taskId");
        Map<String, Object> circulate = bsnMessageApplication.circulate(meId);
        this.putAttribute(circulate);
        SapNonProdApplyDept nonProdApplyDept = nonProdApplyDeptApplication.getNonProdApplyDeptById(bizId);
        if (nonProdApplyDept == null) {
            throw new RuntimeException("不存在该业务或未发布！");
        }
        NonProdApplyBaseInfo baseInfo = nonProdApplyApplication.loadNonProdApplyBaseInfoById(nonProdApplyDept.getBaseInfoId());
         nonProdApplyDept.setBusinessCode(circulate.get("deptCode").toString());
         getBaseInfoAttrs(baseInfo,nonProdApplyDept);

        String businessCode=circulate.get("deptCode").toString();
        switch (businessCode) {
            case "K":
                return forward("nonProdApplyNext", nonProdApplyDept);
            case "C":
                return forward("nonProdApplyClass", nonProdApplyDept);
            case "V":
                return forward("nonProdApplySale", nonProdApplyDept);
            case "E":
                return forward("nonProdApplyPurchase", nonProdApplyDept);
            case "D":
                return forward("nonProdApplyMRP", nonProdApplyDept);
            case "A":
                return forward("nonProdApplyProduce", nonProdApplyDept);
            case "L":
                return forward("nonProdApplyStore", nonProdApplyDept);
            case "S":
                return forward("nonProdApplyWarehouse", nonProdApplyDept);
            case "Q":
                return forward("nonProdApplyMass", nonProdApplyDept);
            case "B":
                return forward("nonProdApplyFinancial", nonProdApplyDept);
            case "G":
                return forward("nonProdApplyCost", nonProdApplyDept);
        }
        return null;
    }

    public String slicedRejectCauseList(){
        SDO sdo = this.getSDO();
        String meId = sdo.getString("meId");
        List<BsnMessageReject> rejectAll = bsnMessageApplication.getRejectDetail(meId);
        return toResult(rejectAll);
    }

public void getBaseInfoAttrs(NonProdApplyBaseInfo baseInfo,SapNonProdApplyDept nonProdApplyDept){
        nonProdApplyDept.setBillCode(baseInfo.getBillCode());
        nonProdApplyDept.setStatusId(baseInfo.getStatusId());
        nonProdApplyDept.setPersonMemberName(baseInfo.getPersonMemberName());
        nonProdApplyDept.setFillinDate(baseInfo.getFillinDate());
        nonProdApplyDept.setMaintenanceType(baseInfo.getMaintenanceType());
        nonProdApplyDept.setBusinessUsage(baseInfo.getBusinessUsage());

        nonProdApplyDept.setId(nonProdApplyDept.getBaseInfoId());
        //物品总属性
        nonProdApplyDept.setGenericName(baseInfo.getGenericName());

        nonProdApplyDept.setApplicableStandard(baseInfo.getApplicableStandard());
        nonProdApplyDept.setBaseUnit(baseInfo.getBaseUnit());
        nonProdApplyDept.setSpecifications(baseInfo.getSpecifications());
        nonProdApplyDept.setMaterial(baseInfo.getMaterial());
        nonProdApplyDept.setDesign(baseInfo.getDesign());
        nonProdApplyDept.setSize(baseInfo.getSize());
        nonProdApplyDept.setBrand(baseInfo.getBrand());
        nonProdApplyDept.setMaterialUsage(baseInfo.getMaterialUsage());
        nonProdApplyDept.setItemAttributes(baseInfo.getItemAttributes());
    }

//    @EasySearch(queryName = "userNameSelect")
//    public Map<String, Object> queryResourceNameGroup(SDO sdo){
//        Integer intPage = sdo.getInteger("intPage", 1);
//        Integer pageSize = sdo.getInteger("pageSize",10);
//        PageRequest pageRequest = new PageRequest(intPage - 1, pageSize);
//        List<QuerySchemeField> fields =
//                Arrays.asList(new QuerySchemeField("id", "id", "hidden"),
//                        new QuerySchemeField("资源名称", "gxmc", "string", 200L),
//                        new QuerySchemeField("资源编码", "gxbm", "string", 100L),
//                        new QuerySchemeField("单位", "dw", "string", 100L),
//                        new QuerySchemeField("用量", "yl", "string", 100L),
//                        new QuerySchemeField("工作中心", "gzzx", "string", 100L));
//        EasySearchParse easySearchParse = new EasySearchParse();
//        easySearchParse.setFields(fields);
//        easySearchParse.setWidth(450L);
//        String processType = sdo.getString("paramValue");
////        List<Map<String, Object>> mapList = resourceFiledService.getResourceFieldValueListByProcess(processType);
//        MemEasySearcher<Map<String, Object>> memEasySearcher = new MemEasySearcherImpl<>();
//        Map<String, Object> model = memEasySearcher.search(mapList, easySearchParse, pageRequest, null);
//        return model;
//        return null;
//    }

    /**
     * 驳回
     * @return
     */
    public String rejectNonProdApplyDept() {
        SDO sdo = this.getSDO();
        nonProdApplyDeptApplication.rejectNonProdApplyDept(sdo);
        return success();
    }
}


