package com.huigou.topsun.sap.nonProducePick.controller;

import com.huigou.context.Operator;
import com.huigou.context.OrgUnit;
import com.huigou.topsun.sap.nonProducePick.application.NonProducePickApplication;
import com.huigou.topsun.sap.nonProducePick.domain.NonProducePick;
import com.huigou.topsun.sap.nonProducePick.domain.query.NonProducePickQueryRequest;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.common.BizBillStatus;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import org.springframework.stereotype.Controller;

import javax.annotation.Resource;
import java.util.Map;

/**
 * @Auther: xin.lu
 * @Date: 2024/03/13/10:45
 * @Description:
 */
@Controller
@ControllerMapping("/nonProducePick")
public class NonProducePickController extends CommonController {
    @Override
    protected String getPagePath() {
        return "/biz/topsun/sap/nonProducePick/";
    }

    @Resource
    private NonProducePickApplication nonProducePickApplication;

    public String forwardNonProducePickList(){
        return forward("nonProducePickList");
    }

    public String slicedNonProducePickList(){
        SDO sdo = this.getSDO();
        NonProducePickQueryRequest queryRequest = sdo.toQueryRequest(NonProducePickQueryRequest.class);
        Map<String, Object> map = nonProducePickApplication.slicedNonProducePickList(queryRequest);
        return toResult(map);
    }

    public String forwardNonProducePickDetail(){
        this.putAttribute("processDefinitionKey", NonProducePickApplication.PROCESS_DEFINITION_KEY);
        // 新增的时候procUnitId一定要设置成Apply，不然jsp页面的所有表单元素是readonly状态
        this.putAttribute("procUnitId", "Apply");
        NonProducePick nonProducePick = new NonProducePick();
        nonProducePick.setStatusId(BizBillStatus.APPLYING.getId());
        /**
         * 设置jsp页面初始化填充数据，如果不设置， 那么在jsp页面上填写完表单之后立即提交申请TaskDescription获取不到时间和相关人员信息
         */
        Operator operator = getOperator();
        nonProducePick.setDefaultValues(new OrgUnit(operator.getFullId(), operator.getFullName()));
        return forward("nonProducePickDetail",nonProducePick);
    }

    public String showNonProducePickDetail(){
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
        NonProducePick nonProducePick = nonProducePickApplication.findNonProducePickById(id);
        return forward("nonProducePickDetail",nonProducePick);
    }
}
