package com.huigou.topsun.sap.priceMasterData.domain.vo;

import com.alibaba.fastjson.JSON;
import com.huigou.topsun.sap.priceMasterData.domain.SapPriceMasterDataItem;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * title:
 * author:ZHT
 * date:2023/12/27
 * description:
 */
@Data
public class SapPriceMasterDataItemVo implements Serializable {
    /**
     * id
     */
    private String id;
    /**
     * 父id
     */
    private String priceMasterDataId;

    /**
     * MATNR-产品物料(可选)
     */
    private String matnr;

    /**
     * KBETR-价格(必输)
     */
    private BigDecimal kbetr;

    /**
     * 币别(必输)
     */
    private String konwa;

    /**
     * 条件单位(必输)
     */
    private String kmein;

    /**
     * 有效期自(必输)
     */
    private Date datab;

    /**
     * 有效期至(必输)
     */
    private Date datbi;

    /**
     * 行号
     */
    private String sequence;

    public static SapPriceMasterDataItem getSapPriceMasterDataItem(SapPriceMasterDataItemVo sapPriceMasterDataItemVo) {
        return JSON.parseObject(JSON.toJSONString(sapPriceMasterDataItemVo), SapPriceMasterDataItem.class);
    }

    public static SapPriceMasterDataItemVo getSapPriceMasterDataItemVo(SapPriceMasterDataItem sapPriceMasterDataItem) {
        return JSON.parseObject(JSON.toJSONString(sapPriceMasterDataItem), SapPriceMasterDataItemVo.class);
    }
}
