package com.huigou.topsun.sap.purchaseInfoRecord.application.impl;

import com.huigou.data.query.model.QueryDescriptor;
import com.huigou.data.query.model.QueryModel;
import com.huigou.topsun.sap.purchaseInfoRecord.application.SapPurchaseInfoRecordItemApplication;
import com.huigou.topsun.sap.purchaseInfoRecord.domain.SapPurchaseInfoRecordItem;
import com.huigou.topsun.sap.purchaseInfoRecord.domain.query.SapPurchaseInfoRecordQueryRequest;
import com.huigou.topsun.sap.purchaseInfoRecord.repository.SapPurchaseInfoRecordItemRepository;
import com.huigou.uasp.bmp.common.application.BaseApplication;
import com.huigou.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther: xin.lu
 * @Date: 2024/02/28/15:40
 * @Description:
 */
@Service("sapPurchaseInfoRecordItemApplication")
public class SapPurchaseInfoRecordItemApplicationImpl extends BaseApplication implements SapPurchaseInfoRecordItemApplication {
    @Autowired
    private SapPurchaseInfoRecordItemRepository sapPurchaseInfoRecordItemRepository;
    @Override
    public void saveSapPurchaseInfoRecordItem(String sapPurchaseInfoRecordId, List<SapPurchaseInfoRecordItem> sapPurchaseInfoRecordItems) {
        sapPurchaseInfoRecordItems.forEach(sapPurchaseInfoRecordItem -> {
            sapPurchaseInfoRecordItem.setSapPurchaseInfoRecordId(sapPurchaseInfoRecordId);
            sapPurchaseInfoRecordItemRepository.save(sapPurchaseInfoRecordItem);
        });
    }

    @Override
    public Map<String, Object> querySapPurchaseInfoRecordItem(SapPurchaseInfoRecordQueryRequest queryRequest) {
        Map<String, Object> map = new HashMap<>();
        if (StringUtil.isNotBlank(queryRequest.getSapPurchaseInfoRecordId())){
            QueryDescriptor queryDescriptor = this.sqlExecutorDao.getQuery(QUERY_XML_FILE_PATH, "sapPurchaseInfoRecordItems");
            QueryModel queryModel = this.sqlExecutorDao.getQueryModel(queryDescriptor, queryRequest);
            map = this.sqlExecutorDao.executeSlicedQuery(queryModel);
        }
        return map;
    }

    @Override
    public void deleteByIds(List<String> ids) {
        ids.forEach(id->{
            sapPurchaseInfoRecordItemRepository.delete(id);
        });
    }

    @Override
    public List<SapPurchaseInfoRecordItem> findBySapPurchaseInfoRecordId(String sapPurchaseInfoRecordId) {
        return sapPurchaseInfoRecordItemRepository.findBySapPurchaseInfoRecordId(sapPurchaseInfoRecordId);
    }

    @Override
    public void save(SapPurchaseInfoRecordItem sapPurchaseInfoRecordItem) {
        sapPurchaseInfoRecordItemRepository.save(sapPurchaseInfoRecordItem);
    }
}
