package com.huigou.topsun.sap.purchaseInfoRecord.domain;

import com.huigou.data.domain.model.AbstractEntity;
import lombok.Data;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Auther: xin.lu
 * @Date: 2024/02/28/15:35
 * @Description:
 */
@Table(name="sap_purchase_info_record_item")
@Entity
@Data
public class SapPurchaseInfoRecordItem extends AbstractEntity {
    /**
     * 采购信息记录id
     */
    @Column(name = "sap_purchase_info_record_id")
    private String sapPurchaseInfoRecordId;
    /**
     * 采购信息记录号
     */
    @Column(name = "INFNR")
    private String infnr;
    /**
     * 采购组织
     */
    @Column(name = "EKORG")
    private String ekorg;
    /**
     * 供应商
     */
    @Column(name = "LIFNR")
    private String lifnr;

    /**
     * 供应商物料编码
     */
    @Column(name = "IDNLF")
    private String idnlf;
    /**
     * 名称 1
     */
    @Column(name = "NAME1")
    private String name1;
    /**
     * 物料编码
     */
    @Column(name = "MATNR")
    private String matnr;
    /**
     * 物料描述
     */
    @Column(name = "MAKTX")
    private String maktx;
    /**
     * 物料组
     */
    @Column(name = "MATKL")
    private String matkl;
    /**
     * 采购信息记录分类
     */
    @Column(name = "ESOKZ")
    private String esokz;
    /**
     * 采购组
     */
    @Column(name = "EKGRP")
    private String ekgrp;
    /**
     * 工厂
     */
    @Column(name = "WERKS")
    private String werks;
    /**
     * 生产版本
     */
    @Column(name = "VERID")
    private String verid;
    /**
     * 净价
     */
    @Column(name = "NETPR")
    private BigDecimal netpr;
    /**
     * 货币码
     */
    @Column(name = "WAERS")
    private String waers;
    /**
     * 价格单位
     */
    @Column(name = "PEINH")
    private String peinh;
    /**
     * 订单价格单位(采购)
     */
    @Column(name = "BPRME")
    private String bprme;
    /**
     * 销售/购买税代码
     */
    @Column(name = "MWSKZ")
    private String mwskz;
    /**
     * 开始生效日期
     */
    @Column(name = "DATAB")
    private Date datab;
    /**
     * 有效期至日期
     */
    @Column(name = "DATBI")
    private Date datbi;
    /**
     * 等级数量
     */
    @Column(name = "KSTBM")
    private BigDecimal kstbm;
    /**
     * 销售员
     */
    @Column(name = "VERKF")
    private String verkf;
    /**
     * 电话
     */
    @Column(name = "TELF1")
    private String telf1;
    /**
     * 基本计量单位
     */
    @Column(name = "MEINS")
    private String meins;
    /**
     * 订单单位到基本单位转换的分母
     */
    @Column(name = "UMREN")
    private BigDecimal umren;
    /**
     * 基本计量单位转换分子
     */
    @Column(name = "UMREZ")
    private BigDecimal umrez;
    /**
     * 原产地国
     */
    @Column(name = "URZLA")
    private String urzla;
    /**
     * 地区
     */
    @Column(name = "REGIO")
    private String regio;
    /**
     * 删除标志
     */
    @Column(name = "LOEKZ")
    private String loekz;
    /**
     * 排序字段
     */
    @Column(name = "SORTL")
    private String sortl;
    /**
     * 标准采购订单数量
     */
    @Column(name = "NORBM")
    private BigDecimal norbm;
    /**
     * 最小采购订单数量
     */
    @Column(name = "MINBM")
    private BigDecimal minbm;
    /**
     * 等级类型
     */
    @Column(name = "STFKZ")
    private String stfkz;
    /**
     * 计划交货时间（天）
     */
    @Column(name = "APLFZ")
    private BigDecimal aplfz;
    /**
     * 传输日期
     */
    @Column(name = "SEND_TIME")
    @Temporal(TemporalType.TIMESTAMP)
    private Date sendTime;


    /**
     * 语言
     */
    @Column(name = "ZYY")
    private String zyy;
    /**
     * 业务标识
     */
    @Column(name = "ZFLAG")
    private String zflag;
    /**
     * 基于收货的发票验证
     */
    @Column(name = "WEBRE")
    private String webre;
    /**
     * 条件类型
     */
    @Column(name = "KSCHL")
    private String kschl;
    /**
     * 价格有效至
     */
    @Column(name = "PRDAT")
    private Date prdat;
    /**
     * 订单价格单位转换为订单单位的分母
     */
    @Column(name = "BPUMN")
    private BigDecimal bpumn;
    /**
     * 订单价格单位转换为订单单位的分子
     */
    @Column(name = "BPUMZ")
    private BigDecimal bpumz;
    /**
     *条件等级计量单位
     */
    @Column(name = "KONMS")
    private String konms;
    /**
     *价格
     */
    @Column(name = "KBETR")
    private BigDecimal kbetr;

    /**
     * 消息类型
     */
    @Column(name = "TYPE")
    private String TYPE;

    /**
     * 消息文本
     */
    @Column(name = "MESSAGE")
    private String MESSAGE;


}
