package com.huigou.topsun.sap.sapApplication.application.impl;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.huigou.topsun.sap.common.HttpClient;
import com.huigou.topsun.sap.purchaseInfoRecord.domain.SapResult;
import com.huigou.topsun.sap.sapApplication.domain.query.SapDialogQuery;
import com.huigou.topsun.sap.sapApplication.application.SapMaterialApplication;
import com.huigou.topsun.sap.sapApplication.domain.vo.SapMaterialVo;
import com.huigou.util.JSONUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Auther: xin.lu
 * @Date: 2024/03/03/11:13
 * @Description:
 */
@Service("sapMaterialApplication")
public class SapMaterialApplicationImpl implements SapMaterialApplication {
    @Resource
    private HttpClient httpClient;
    @Override
    public List<SapMaterialVo> getSapMaterial(SapDialogQuery queryRequest) throws IOException {
        List<SapMaterialVo> sapMaterialVoList = new ArrayList<>();
        /*if (StringUtil.isBlank(queryRequest.getWerks()) || StringUtil.isBlank(queryRequest.getMatkl())){
            return sapMaterialVoList;
        }*/
        String paramJson = new ObjectMapper().writeValueAsString(queryRequest);
        String json = httpClient.executeByJson(paramJson, "search/sch_matnr");
        Map<String, Object> map = JSONUtil.toMap(json);
        SapResult sapResult = JSONObject.parseObject(JSONUtil.toString(map.get("MSG")), SapResult.class);
        if ("S".equals(sapResult.getTYPE())){
            sapMaterialVoList = JSONObject.parseArray(JSONUtil.toString(map.get("RDATA")), SapMaterialVo.class);
        }else {
            throw new RuntimeException("查询物料失败："+sapResult.getMESSAGE());
        }
        return sapMaterialVoList;
    }
}
