package com.huigou.topsun.sap.wasteSale.domain;

import com.huigou.data.domain.model.AbstractEntity;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.math.BigDecimal;

/**
 * @Auther: xin.lu
 * @Date: 2024/03/13/19:06
 * @Description:
 */
@Data
@Entity
@Table(name = "sap_waste_sale_item")
public class WasteSaleItem extends AbstractEntity {

    @Column(name = "waste_sale_id")
    private String wasteSaleId;

    /**
     * 序号
     */
    @Column(name = "sequence")
    private Integer sequence;

    /**
     * 回收品类
     */
    @Column(name = "waste_type")
    private String wasteType;

    /**
     * 数量
     */
    @Column(name = "quantity")
    private BigDecimal quantity;

    /**
     * 单价
     */
    @Column(name = "price")
    private BigDecimal price;

    /**
     * 计量单位
     */
    @Column(name = "unit")
    private String unit;

    @Column(name = "unit_name")
    private String unitName;

    /**
     * 总价
     */
    @Column(name = "amount")
    private BigDecimal amount;

}
